module svncmd {

	let path, fs, buffer, cp;
    let require = window["nodeRequire"];
    if (typeof require === "function") { //是Electron环境
        path = require("path");
        fs = require("fs");
        buffer = require("buffer");
		cp = require("child_process");
    }

    export var errorLog;

	/**
	 * svn update 指定目录内容
	 */
	export function update(root: string)
	{
		return new Promise((suc, failed)=>{
            let exec = cp.exec;
            exec(`svn update ${root}`, function callback(err, stdout, stderr){
                if (stderr) {
                    traceError("svn update failed【失败 失败 失败】" + `[${root}]  __ ${stderr}`);
                    failed("svn update failed【失败 失败 失败】" + `[${root}]  __ ${stderr}`);
                }
                else {
                    suc("svn update ok【 successful  successful  successful 】");
                    console.log(`svn update successful`, stdout);
                }
            });
		})
	}

	/**
	 * 添加指定svn目录下所有文件到 svn 版本控制
	 */
	export function add(addRoot)
	{
		return new Promise((suc, failed)=>{
            var exec = cp.exec;
            exec(`svn status ${addRoot}`,function callback(error, stdout, stderr) {
                try{
                    let result: string = stdout;
                    if (result){
                        let arg = result.split("\r\n");
                        if (arg && arg.length > 0){
                            let next = async ()=>{
                                if (arg.length > 0){
                                    let temp = arg.pop().replace(/\s/g, "");
                                    if (temp){
                                        if(temp.substring(0,1)=='?'){
                                            try{
                                                let filepath = temp.substring(temp.indexOf(addRoot.substring(2, 8)) - 2);
                                                filepath = getPathFromOldByNew(addRoot, filepath);
                                                await realAdd(filepath);
                                            } catch (e) {
                                                traceError("svn status function === ", e);
                                            }
                                        }
                                    }
                                    next();
                                } else {
                                    suc("ok");
                                }
                            }
                            next();
                        }
                    } else {
                        suc("ok");
                    }
                } catch (e) {
                    traceError("svn add failed【失败 失败 失败】", e);
                    failed(e.message);
                }
            })
        })
	}

	/**
	 * 提交内容到 svn 服务器
	 */
	export function commit(commitRoot, desc)
	{
		return new Promise((suc, failed)=>{
			var exec = cp.exec;
            exec(`svn status ${commitRoot}`,function callback(error, stdout, stderr) {
                console.log(error, stdout, stderr);
                try{
                    if (stdout){
                        let result: string = stdout;
                        if (result){
                            let arg = result.split("\r\n");
                            if (arg && arg.length > 0){
                                let next = async()=>{
                                    if (arg.length > 0){
                                        let temp = arg.pop().replace(/\s/g, "");
                                        if (temp){
                                            let f = temp.substring(0,1);
                                            if (["?","!","M","A"].indexOf(f) != -1) {
                                                let filepath = temp.substring(temp.indexOf(commitRoot.substring(2, 8)) - 2);
                                                filepath = getPathFromOldByNew(commitRoot, filepath);
                                                if(f=='?'){
                                                    try{ await realAdd(filepath); } catch (e) { traceError("", e); }
                                                }
                                                try{ await realCommit(filepath, desc); } catch (e) { traceError("", e); }
                                            }
                                        }
                                        next();
                                    } else {
                                        suc("ok");
                                    }
                                }
                                next();
                            } else {
                                suc("ok");
                            }
                        } else {
                            suc("ok");
                        }
                    }
                    else if (stderr) {
                        traceError("[commit]svn status stderr"+stderr);
                        failed("[commit]svn status stderr"+stderr);
                    } else {
                        suc("ok");
                    }
                } catch (e) {
                    traceError("failed", e);
                    failed(e.message);
                }
            });
		})
    }

    export function cleanup(root: string)
    {
        return new Promise((suc, failed)=>{
            let exec = cp.exec;
            exec(`svn cleanup ${root}`, function callback(err, stdout, stderr){
                if (stderr) {
                    traceError("svn cleanup failed【失败 失败 失败】" + `[${root}]  __ ${stderr}`);
                    failed("svn cleanup failed【失败 失败 失败】" + `[${root}]  __ ${stderr}`);
                }
                else {
                    suc("svn cleanup ok【 successful  successful  successful 】");
                    console.log(`svn cleanup successful`, stdout);
                }
            });
		})
    }

    function traceError(msg, e?)
    {
        if (errorLog) errorLog(msg, e);
        else console.error(msg + ` ___ ${e?e.message:""}`);
    }

    function getPathFromOldByNew(oldpath: string, newpath: string)
    {
        let oldNames = path.normalize(oldpath).split(path.sep);
        let newNames = path.normalize(newpath).split(path.sep);
        let prex = oldpath.indexOf("\\") == 0 || oldpath.indexOf("//") == 0 ? `\\\\` : "";
        let rpath = "";
        for (let i = 0, l= newNames.length; i < l; i++){
            if (!rpath) rpath = oldNames[i];
            else {
                let t = oldNames[i] || newNames[i];
                rpath = path.join(rpath, t);
            }
        }
        rpath = prex + rpath;
        return rpath;
    }

    function realAdd(filepath)
    {
        return new Promise((ssuc, sfail)=>{
			var exec = cp.exec;
            exec(`svn add ${filepath}`,function callback(error, stdout, stderr) {
                console.log("realAdd error:"+error);
                console.log("realAdd stdout:"+stdout);
                if (stderr) {
                    traceError("svn add failed【失败 失败 失败】" + `[${filepath}]`);
                    sfail("sfailed");
                }
                else {
                    console.log("svn add ok【 successful  successful  successful 】");
                    ssuc("sok");
                }
            });
        })
    }

    function realCommit(filepath, desc)
    {
        return new Promise((ssuc, sfail)=>{
			var exec = cp.exec;
            exec(`svn commit ${filepath} -m "${desc}`,function callback(error, stdout, stderr) {
                console.log("realCommit error:"+error);
                console.log("realCommit stdout:"+stdout);
                if (stderr) sfail("svncommit sfail");
                else {
                    console.log("svn commit ok【 successful  successful  successful 】");
                    ssuc("svncommit ok");
                }
            });
        })
    }
}