import $path = require("path");
import $fs = require("fs");
import $XLSX = require("xlsx");
declare var XLSX: typeof $XLSX;
const path: typeof $path = nodeRequire("path");
const fs: typeof $fs = nodeRequire("fs");
const clipboard = nodeRequire('electron').clipboard;
import { TypeCheckers } from "./TypeCheckers";
import { genManualAreaCode, getManualCodeInfo, ManualCodeDefaultComment, getGConfigCodeInfo } from "./MenualCodeHelper";
import asyncFileLoad from "asyncFileLoad";
import $vm = require("vm");

var $g: any = (id) => { return document.getElementById(id) };
/**
 * 输出日志
 */
function log(msg: string) {
    let txtLog = $g("txtLog");
    if (txtLog) {
        txtLog.innerHTML += msg + "<br/>";
        txtLog.scrollTop = txtLog.scrollHeight;
    }
}

/**
 * 输出错误
 */
function error(msg: string, err?: Error) {
    let errMsg = "";
    if (err) {
        errMsg = `
<font color="#f00"><b>err:</b></font>
${err.message}
<font color="#f00"><b>stack:</b></font>
${err.stack}`
    }
    log(`<font color="#f00">${msg}</font>${errMsg}`);
}

/**
 * 给消息内网前面添加当前时间
 * @param message 消息内容
 */
function addTimeForMessage(message){
    if (/\[[0-9]\d:[0-5]\d:[0-5]\d\]/.test(message)) return message;
    return `[${new Date().toTimeString().slice(0,8)}] ${message} <br/>`;
}

interface FileData
{
    path: string;

    name: string;
}

interface NetParam
{
    cmd: string;
    data: string;
}


// var tcpClient;
var errorMessages: string[] = [];

function endCallBack()
{
    let temp = errorMessages;
    while (temp.length > 0){
        error(temp.pop());
    }
    send2ServerFromEnd();
    alert("所有数据保存完成");
}
function ifErrorCallBack()
{
    let temp = errorMessages;
    while (temp.length > 0){
        error(temp.pop());
    }
    send2ServerFromEnd();
    alert("执行配置合并脚本过程中未能完成");
}

function send2ServerFromEnd(m = "0")
{
    // try{
    //     if (tcpClient){
    //         tcpClient.write(encode("publish_data_tools_parse", m));// 客户端向服务器发送信息
    //     }
    // } catch (e) {
    //     alert("少年，你可能需要刷新才能继续使用，或者服务端程序已关闭");
    // }
}

/**
 * 编码
 */
function encode(cmd: string, ...param){
    let result = <NetParam>{cmd, data: encodeParam(...param)};
    return JSON.stringify(result);
}

function encodeParam(...param){
    if (param) return param.join("|");
    return "";
}

/**
 * ExcelDataSaver
 */
export class ExcelDataSaver {
    constructor() {
        ready(() => {

            svncmd.errorLog = error;

            var net = nodeRequire("net");
            var isDoing = false;

            // 创建客户端
            // tcpClient = net.Socket();

            // // 监听“服务器发来信息”事件
            // tcpClient.on('data',function(data){
            //     let content: string = data.toString();
            //     if (content.indexOf("alert|") != -1){
            //         alert(content.substr(6));
            //     } else {
            //         let param = content.split("|");
            //         let result = param[0];
            //         if (result == "0") isDoing = false;
            //         else if (result == "1") isDoing = true;
            //         log(addTimeForMessage(content));
            //         log(addTimeForMessage(`isDoing=${isDoing}`));
            //     }
            // });
            // // tcpClient.connect(18002,'192.168.99.84',function(){
            // tcpClient.connect(18002,'client.uclub.xyz',function(){
            //     log("Connect success");
            // });
            // tcpClient.on('error', function(err){  
            //     error('Server error:'+err.message);
            //     isDoing = true;
            //     alert("少年，你可能需要刷新才能继续使用，或者服务端程序未启动");
            // }); 

            window.addEventListener("dragover", e => {
                e.preventDefault();
                return false;
            });

            window.addEventListener("drop", e => {
                e.preventDefault();
                if(isDoing){
                    alert("少年，我是单线程操作，不好意思已经被别人占用中，稍后再试。麻烦关闭提示框，你很配合的");
                } else {

                    let files = e.dataTransfer.files;

                    if (!files || files.length == 0) {
                        alert("少年你这样操作，三亿让你请饭哦");
                        return ;
                    }
                    
                    // try{
                    //     if (tcpClient){
                    //         tcpClient.write(encode("publish_data_tools_parse", "1"));// 客户端向服务器发送信息
                    //     }
                    // } catch (e) {
                    //     error("socket ===== ", e);
                    //     alert("少年，似乎请求服务器失败，刷新试试吧。");
                    //     return ;
                    // }
                    
                    isDoing = false;
                    this.onDrop(files);
                }
                return false;
            });
            this.getPathCookie("txtClientPath");
            this.getPathCookie("txtServerPath");
            $g("chkClientPath").checked = cookie.getCookie("h5excel_chkClientPath") == "true";
            $g("chkServerPath").checked = cookie.getCookie("h5excel_chkServerPath") == "true";
        });
    }

    private getPathCookie(id: string) {
        let sPath = cookie.getCookie("h5excel_" + id);
        if (sPath) {
            $g(id).value = sPath;
        }
    }

    private setPathCookie(id: string): string {
        let v: string = $g(id).value;
        v = v.trim();
        $g(id).value = v;
        if (v && fs.existsSync(v)) {
            let re = fs.statSync(v);
            if (re.isDirectory()) {
                cookie.setCookie("h5excel_" + id, v)
                return v;
            }
        }
        return undefined;
    }

    private checkFiles = (rootpath, resultFiles: FileData[]) =>{
        
        let basename = path.basename(rootpath);
        var stat = fs.statSync(rootpath);
        let self = this;
        if (stat.isDirectory()){
            let temp = fs.readdirSync(rootpath);
            temp.forEach(function(item, index){
                self.checkFiles(path.join(rootpath,item), resultFiles);
            })
        } else {
            resultFiles.push({path: rootpath, name: basename});
        }
    }

    private async onDrop(files: FileList) {
        if (files.length == 0) return ;
        let resultFiles: FileData[] = [];
        for (let i = 0, len = files.length; i < len; i++) {
            this.checkFiles(files[i].path, resultFiles);
        }

        let gcfg: GlobalCfg;
        let cPath = this.setPathCookie("txtClientPath");
        let sPath = this.setPathCookie("txtServerPath");

        let useClientPath = $g("chkClientPath").checked;
        cookie.setCookie("h5excel_chkClientPath", useClientPath);
        let useServerPath = $g("chkServerPath").checked;
        cookie.setCookie("h5excel_chkServerPath", useServerPath);
        if (!useClientPath) {
            cPath = "";
        }
        if (!useServerPath) {
            sPath = "";
        }
        // 清理code区
        $g("code").innerHTML = "";
        $g("txtLog").innerHTML = "";
        let xlsxRoot = "";
        let unsolved = resultFiles.concat();//Array.from(files);
        // 每拖一次文件，只加载一次全局配置
        for (let i = 0, len = resultFiles.length; i < len; i++) {
            let file = resultFiles[i];
            let re = path.parse(file.name);
            console.log("************" + file.path);
            if (re.ext == ".xlsx") { // 只处理Excel
                if (!gcfg || !gcfg.project) {
                    // 得到全局配置路径
                    let globalCfgPath = path.join(file.path, "../..", "globalConfig.json");
                    gcfg = this.getGlobalCfg(globalCfgPath);
                    if (gcfg) {
                        if (gcfg.remote) { // 当前全局配置，如果配了远程路径，加载远程路径
                            gcfg = this.getGlobalCfg(gcfg.remote);
                        }
                    } else {
                        gcfg = {
                            project: "common",
                            clientPath: "",
                            isAutoSvn: false
                        }
                    }
                    xlsxRoot = path.join(file.path, "../..");
                }
                if (!gcfg.serverPath) {
                    gcfg.serverPath = path.join(file.path, "../..", "data", "server");
                    mkdirs(gcfg.serverPath);
                }
                if (!gcfg.clientPath) {
                    gcfg.clientPath = path.join(file.path, "../..", "data", "client", "raw");
                    mkdirs(gcfg.clientPath);
                }
                break;
            }
        }
        if (!gcfg){
            error("没有 xlsx 配置文件  当前操作无效");
            send2ServerFromEnd();
            return ;
        }
        if (!("isAutoSvn" in gcfg)){
            gcfg.isAutoSvn = false;
        }
        console.log("clientPath", gcfg.clientPath);
        console.log("serverPath", gcfg.serverPath);

        if (gcfg.isAutoSvn){
            try{
                //await svncmd.cleanup(gcfg.clientPath);// 此目录不是在每个人的本地，所以操作前执行一次cleanup，防止某些错误出现
                // await svncmd.update(gcfg.clientPath);
                // await svncmd.update(gcfg.serverPath);

                // 自动更新配置文件根目录svn
                await svncmd.update(xlsxRoot);
    
            } catch (e) {
                send2ServerFromEnd();
    
                alert("解析被终止，未能完成，请看日志输出信息，解决错误后再重试。优秀的你请关闭当前提示");
    
                return ;
            }
        }

        let cb = (file: FileData, err: boolean) => {
            let idx = unsolved.indexOf(file);
            if (~idx) {
                unsolved.splice(idx, 1);
            }
            if (unsolved && unsolved.length == 0) {//全部文件处理完成

                unsolved = undefined;
                
                this.completeSaveAndDoAction(gcfg);
            }
        }

        errorMessages = [];

        // 遍历所有目录及文件
        for (let i = 0, len = resultFiles.length; i < len; i++) {
            let file = resultFiles[i];
            let re = path.parse(file.name);
            if (re.ext == ".xlsx") { // 只处理Excel
                new XLSXDecoder(gcfg, file, cPath, sPath, i, cb);
            }
        }
    }

    private async completeSaveAndDoAction(gcfg: GlobalCfg) 
    {
        let self = this;
        console.log("开始 Start svn 操作");
        // 分别用 try  是因为某些目录可能存在没有更新而进行操作报错， 这是为了确保每个各自的命令都能执行
        if (gcfg.isAutoSvn){
            // try{
            //     await svncmd.add(gcfg.clientPath);
            // } catch (e) {
            //     error(`add ${gcfg.clientPath}`,e);
            // }
            // try{
            //     await svncmd.commit(gcfg.clientPath, "client工具自动提交日志");
            // } catch (e) {
            //     error(`commit ${gcfg.clientPath}`,e);
            // }
    
            try{
                await svncmd.add(gcfg.serverPath);
            } catch (e) {
                error(`add ${gcfg.serverPath}`,e);
            }
            try{
                await svncmd.commit(gcfg.serverPath, "server工具自动提交日志");
            } catch (e) {
                error(`commit ${gcfg.serverPath}`,e);
            }
        }
        console.log("结束 End svn 操作");
        //检查是否有完结处理
        // if (gcfg.endScript) {
        //     asyncFileLoad(gcfg.endScript, (er, data) => {
        //         if (er) {
        //             error(`处理加载结束脚本出错，${gcfg.endScript}`, er);
        //             send2ServerFromEnd();
        //             return
        //         }
        //         if (data) {
        //             let script = data.toString();
        //             let vm: typeof $vm = nodeRequire("vm");
        //             let endScript = vm.createContext({ 
        //                                                 ifErrorCallBack: ifErrorCallBack,
        //                                                 endCallBack: endCallBack,
        //                                                 require: nodeRequire, 
        //                                                 traceLog: log, 
        //                                                 console: console, 
        //                                                 gcfg: gcfg });
        //             try {
        //                 vm.runInContext(script, endScript);
        //             } catch (err1) {
        //                 error(`处理执行结束脚本出错，${gcfg.endScript}`, err1);
        //                 send2ServerFromEnd();
        //             }
        //         }
        //     });
        // }

        // try{
        //     pakdata.endCallBack = endCallBack;
        //     pakdata.ifErrorCallBack = ifErrorCallBack;
        //     pakdata.traceLog = log;
        //     pakdata.isAutoSvn = gcfg.isAutoSvn;
        //     pakdata.initPathVars(gcfg.clientPath);
        //     await pakdata.packageForClient();
        // }
        // catch (e) {
        //     error(`处理执行结束脚本出错，${gcfg.endScript}`, e);
        //     send2ServerFromEnd();
        // }

    }

    /**
     * 获取全局配置
     */
    private getGlobalCfg(globalCfgPath: string): GlobalCfg {
        let cfg: GlobalCfg;
        if (fs.existsSync(globalCfgPath)) {
            // 加载全局配置
            let globalJSON = fs.readFileSync(globalCfgPath, "utf8");

            try {
                cfg = <GlobalCfg>JSON.parse(globalJSON);
            } catch (e) {
                error("全局配置加载有误");
            }
        }
        return cfg;
    }
}

new ExcelDataSaver();

/**
 * XLSX解析器
 */
class XLSXDecoder {

    /**
     * 创建一个代码区
     * 
     * @private
     * @param {HTMLElement} parent (description)
     * @param {string} filename (description)
     * @param {number} idx (description)
     * @param {string} ccode (description)
     * @param {string} scode (description)
     */
    private createContent(parent: HTMLElement, filename: string, idx: number, ccode: string, scode: string) {
        let pane = document.createElement("div");
        pane.style.border = "#000 solid 1px";
        let idCopyClient = "btnCopyClient" + idx;
        let idCopyServer = "btnCopyServer" + idx;
        let template = `<div>${filename}</div>
    <div style="width:50%;height:50%;float:left;background:#eef">
        客户端代码：<input type="button" value="复制客户端代码" id="${idCopyClient}" />
        <textarea style="width:100%;height:200px;border:#ccf solid 1px;background:#eee" contenteditable="false">${ccode}</textarea>
    </div>
    <div style="width:50%;height:50%;float:left;background:#fee">
        服务端代码：<input type="button" value="复制服务端代码" id="${idCopyServer}" />
        <textarea style="width:100%;height:200px;border:#fcc solid 1px;background:#eee" contenteditable="false">${scode}</textarea>
    </div>`
        pane.innerHTML = template;
        parent.appendChild(pane);
        $g(idCopyClient).addEventListener("click", e => {
            clipboard.writeText(ccode);
        });
        $g(idCopyServer).addEventListener("click", e => {
            clipboard.writeText(scode);
        });

    }

    constructor(gcfg: GlobalCfg, file: FileData, cPath: string, sPath: string, idx: number, cb: { (file: FileData, error: boolean) }) 
    {
        cPath = cPath || "";
        sPath = sPath || "";
        let fre = path.parse(file.name);
        let fname = fre.name;
        let data = fs.readFileSync(file.path, "base64");
        let wb = XLSX.read(data);
        let sheetNames = wb.SheetNames;
        
        let rowCfgs: { [index: string]: string } = {
            // 第一列的中文: 对应后续用到的属性
            "前端解析": "clientRow",
            "后端解析": "serverRow",
            "数据类型": "typeRow",
            "字段描述": "desRow",
            "字段名称": "nameRow",//必须为配置的最后一行
            "server": "serverPkg",
            "client": "clientPkg",
        }
        
        for (let sheetName of sheetNames) {
            var Regx = /(^[A-Za-z0-9]+$)/;
            if (!Regx.test(sheetName)) {
                continue;
            }
            sheetName.replace(/^\S/, function (s) { return s.toUpperCase(); });
            let list = XLSX.utils.sheet_to_json(wb.Sheets[sheetName], { header: 1 });
            let len = list.length;
            fname = getJavaName(sheetName);

            let isDirty = fre.base == gcfg.dirtyName || fre.name == gcfg.dirtyName;
            let isNameLib = fre.base == gcfg.nameLib || fre.name == gcfg.nameLib;
            let dirtyData: string[] = [];
            let nameLibData: {[key: string]: string[]} = {};

            let cpkgtemplete = "chuanqi/module/{moduleName}/cfg";
            let cfilePackage = "";
            let sfilePackage = "";
            let sortName = "";
            let extendsName = "";
            let implementsName = "";
            /**
              * 数据起始行
              */
            let dataRowStart: number = 0;
            let rowCfgLines: { [index: string]: number } = {};
            // 先遍历所有行，直到得到"属性名称"行结束
            for (let i = 0; i < len; i++) {
                let rowData = list[i];
                let col1 = rowData[0];
                if (col1 in rowCfgs) {
                    let key = rowCfgs[col1];
                    if (key != null) {
                        rowCfgLines[key] = i;
                        if (key == "nameRow") {
                            dataRowStart = i + 1;

                            if (!isDirty && !isNameLib){
                                rowData = list[i + 1];
                                if (rowData){
                                    col1 = rowData[0];
                                    if (col1){
                                        let reg = /[a-zA-Z]/;
                                        if (reg.test(col1)){
                                            col1 = col1.toLowerCase();
                                        } else {
                                            col1 = "";
                                        }
                                    }
                                    sfilePackage = col1 ? col1.toLowerCase() : "defaultcfg";
                                    cfilePackage = cpkgtemplete.replace(/{moduleName}/g, sfilePackage);
        
                                    rowData = list[i + 2];
                                    if (rowData){
                                        col1 = rowData[0] || sfilePackage;
                                        
                                        if (col1){

                                            let reg = /[a-zA-Z]/;
                                            if (reg.test(col1)){
                                                col1 = col1.toLowerCase();
                                            } else {
                                                col1 = "";
                                            }
                                        }

                                        cfilePackage = cpkgtemplete.replace(/{moduleName}/g, col1.toLowerCase());
                                    }
        
                                    console.log("package name =========", cfilePackage, sfilePackage);
                                }
                                // 排序字段名
                                rowData = list[i + 3];
                                if (rowData){
                                    sortName = rowData[0];
                                }

                                // 要继承的 类 [extend class]
                                rowData = list[i + 4];
                                if (rowData){
                                    extendsName = rowData[0];
                                }

                                rowData = list[i + 5];
                                if (rowData){
                                    implementsName = rowData[0];
                                }
                            }

                            break;
                        }
                    }
                }
            }
            let defines: ProDefine[] = [];
            let cdatas = [];
            let sdatas = [];
            /** 前端是否解析此数据 */
            let clientRow = list[rowCfgLines["clientRow"]];
            /** 后端是否解析此数据 */
            let serverRow = list[rowCfgLines["serverRow"]];
            /** 类型列 */
            let typeRow = list[rowCfgLines["typeRow"]];
            /** 描述列 */
            let desRow = list[rowCfgLines["desRow"]];
            /** 属性名称列 */
            let nameRow: any = list[rowCfgLines["nameRow"]];

            let max = 0;
            let checkers = TypeCheckers;
            if (!isDirty){
                for (let key in nameRow) {
                    let col = +key;
                    if (col > 0){
                        let client = +clientRow[col];
                        let server = +serverRow[col];
                        let type = typeRow[col] || "any";
                        let checker = checkers[type];
                        let desc = "" + desRow[col];
                        let name = "" + nameRow[col];
                        if (!checker){
                            checker = checkers["any"];

                            let m = `解析${fname}，第${XLSX.utils.encode_col(col)}列数据类型有误：不可识别类型为 ${type}`;
                            error(m);
                            errorMessages.push(m);
                        }
                        defines[col] = { client: client, server: server, checker: checker, name: name, desc: desc, type: "String" };
                        if (col > max) {
                            max = col;
                        }
                    }
                }
            }
            // 从第5行开始，是正式数据
            for (let row = dataRowStart; row < len; row++) 
            {
                let i = 0;
                let rowData = list[row];
                if (isDirty){
                    let s = rowData[1];
                    if (s){
                        let booo = true;
                        for (let iii  = 0, lll = dirtyData.length; iii < lll; iii++){
                            let ss = dirtyData[iii];
                            if (ss.indexOf(s) != -1 || ss == s || s.indexOf(ss) != -1){
                                if (ss.length > s.length){
                                    dirtyData[iii] = s;
                                }
                                booo = false;
                                break;
                            }
                        }
                        if (booo) dirtyData.push(s);
                    }
                    continue;
                } 
                if (isNameLib){
                    let s = rowData;
                    if (s){
                        let pa = s[2], pb = s[3], pc1= s[4], pc2= s[5];
                        if (pa) {
                            let al = nameLibData["a"] || [];
                            al.push(pa);
                            nameLibData["a"] = al;
                        }
                        if (pb) {
                            let bl = nameLibData["b"] || [];
                            bl.push(pb);
                            nameLibData["b"] = bl;
                        }
                        if (pc1) {
                            let c1l = nameLibData["c1"] || [];
                            c1l.push(pc1);
                            nameLibData["c1"] = c1l;
                        }
                        if (pc2) {
                            let c2l = nameLibData["c2"] || [];
                            c2l.push(pc2);
                            nameLibData["c2"] = c2l;
                        }
                        
                    }
                    continue;
                }
                // 先做空行检查，减少误报信息
                // 只判断第1列(一般为id列)是否为空, 来判断是否为空行 2020-10-22
                let flag = !!rowData[1];
                // for (let col = 1; col <= max; col++) {
                //     let cell = rowData[col];
                //     let def = defines[col];
                //     // 没有def的为注释列
                //     if (def && cell != void 0 && (def.client || def.server)) {
                //         flag = true;
                //     }
                // }
                if (flag) {
                    let cRow = [];
                    let sRow: { [index: string]: string } = {};
                    for (let col = 1; col <= max; col++) {
                        try {
                            let def = defines[col];
                            if (!def) {
                                continue;
                            }
                            let cell = rowData[col];
                            if (def.client) {
                                let dat = def.checker.check(cell || "");
                                cRow.push(dat);
                            }
                            if (def.server){
                                let dat = def.checker.checkServer(cell || "");
                                sRow[nameRow[col]] = dat;
                            }
                        } catch (e) {
                            let m = `解析${fname}第${row + 1}行，第${XLSX.utils.encode_col(col)}列数据有误：${e.message}`;
                            error(m);
                            errorMessages.push(m);
                            send2ServerFromEnd(m);
                            ifErrorCallBack();
                            return;
                        }
                    }
                    if (cRow.length) {
                        cdatas.push(cRow);
                    }
                    if (sRow) {
                        sdatas.push(sRow);
                    }
                }
                i++;
            }
            
            var _self = this;
            if (isDirty){
                writeDirtyData(gcfg, dirtyData);
                cb(file, false);
            } 
            else if (isNameLib){
                writeNameLibData(gcfg, nameLibData);
                cb(file, false);
            }
            else {
                writeDesignData(cdatas, sdatas, sheetName, gcfg);
                writeData();
            }
            /**
             * 写最终数据
             * @param {any[]} cdatas
             * @param {any[]} sdatas
             */
            function writeData() {

                let cPros = "";
                let cDecode = "";
                let sPros = "";
                let cout: string = "", sout: string = "";
                for (let define of defines) {
                    if (!define) {
                        continue;
                    }
                    let checker = define.checker;
                    let desc = define.desc.replace(/\r\n/g, "  \n\t\t* ");
                    let noSymbol = getNameNoSymbol(define.name);
                    let pro = clientVarsTemplateCode.replace(/{desc}/g, desc).replace(/{varName}/g, define.name).replace(/{varType}/g, checker.type);
                    let jpro = serverVarsTemplateCode.replace(/{desc}/g, desc)
                                                 .replace(/{cfgName}/g, define.name)
                                                 .replace(/{varType}/g, checker.javaType)
                                                 .replace(/{varName}/g, noSymbol)
                                                 .replace(/{getJavaName}/g, getJavaName(noSymbol));
                    let decode = "";
                    let client = define.client;
                    let tmp: string;
                    if (client) {
                        if (checker.solveString) {
                            decode = `\n\t\t\t@target@.${define.name} = ${checker.solveString.substitute({ value: "data[i++]" })};`;
                        } else {
                            decode = `\n\t\t\t@target@.${define.name} = data[i++];`;
                        }
                        if (client == 1) {
                            cPros += pro;
                            tmp = decode.replace("@target@", "self");
                        } else if (client == 2) {
                            tmp = decode.replace("@target@", "local");
                        }
                        cDecode += tmp;
                    }
                    let server = define.server;
                    if (server) {
                        decode = `\t\t@target@.${define.name} = (${checker.javaType})data[i++];`;
                        sPros += jpro;
                        tmp = decode.replace("@target@", "this");
                    }
                }
                let createTime = new Date().format("yyyy-MM-dd HH:mm:ss");
                let cdict = getManualCodeInfo(path.join(cPath, cfilePackage || "", fname + "Cfg.ts"));
                let clientConfigOut = "";
                // 生成客户端代码
                if (cPros) {
                    // let clientTemplatePath = path.join(__dirname, "template", "client.template");
                    // if (fs.existsSync(clientTemplatePath)) {
                        //读取文件内容
                        let content = clientConfigTemplateCode;//fs.readFileSync(clientTemplatePath, "utf8");

                        let area1 = genManualAreaCode("$area1", cdict);
                        let area2 = genManualAreaCode("$area2", cdict);
                        let area3 = genManualAreaCode("$area3", cdict);
                        let decode = genManualAreaCode("$decode", cdict);
                        let extendsImplements = (extendsName ? ` extends ${extendsName}` : "") + (implementsName ? ` implements ${implementsName}` : "");

                        let filePath = file.path;
                        let indexTrunk = filePath.lastIndexOf("trunk\\");
                        filePath = filePath.substring(Math.max(0, indexTrunk));
                        content = content.replace(/\{filePath\}/g, filePath);
                        content = content.replace(/\{createTime\}/g, createTime);
                        content = content.replace(/\{className\}/g, getJavaName(fname));
                        content = content.replace(/\{configName\}/g, fname);
                        content = content.replace(/\{vars\}/g, cPros);
                        content = content.replace(/\{area1\}/g, area1);
                        content = content.replace(/\{area2\}/g, area2);
                        content = content.replace(/\{area3\}/g, area3);
                        content = content.replace(/\{decode\}/g, decode);
                        content = content.replace(/\{decodeValue\}/g, cDecode);
                        content = content.replace(/\{extends_implements\}/g, extendsImplements);

                        cout = content;
                    // }

                    
                    let tempfilename = getJavaName(fname);
                    let gconfigcontent = getGConfigCodeInfo(path.join(cPath, "chuanqi", "GConfig.ts"), tempfilename, sortName);
                    if (gconfigcontent){
                        let tempcode = clientGConfigScriptTemplateCode;
                        tempcode = tempcode.replace(/{content}/,gconfigcontent);
                        clientConfigOut = tempcode;
                    }
                }

                // 生成服务端代码
                if (sPros) {
                    //template
                    // let serverTemplatePath = path.join(__dirname, "template", "server.template");
                    // if (fs.existsSync(serverTemplatePath)) {
                        //读取文件内容
                        let content = serverConfigTemplateCode;//fs.readFileSync(serverTemplatePath, "utf8");
                        content = content.replace(/\{filePath\}/g, file.path);
                        content = content.replace(/\{createTime\}/g, createTime);
                        content = content.replace(/\{configName\}/g, fname);
                        content = content.replace(/\{className\}/g, getJavaName(fname));
                        content = content.replace(/\{vars\}/g, sPros);
                        content = content.replace(/\{packageName\}/g, sfilePackage);

                        sout = content;
                    // }
                }

                // _self.createContent($g("code"), fname, idx, cout, sout);
                // 尝试存储文件
                
                if (sheetName != "CfgsSpiltInfo"){
                    if (clientConfigOut){
                        _self.saveCodeFile(cPath, "chuanqi", clientConfigOut, "GConfig");
                    }
                    _self.saveCodeFile(cPath, cfilePackage, cout, getJavaName(fname) + "Cfg");
                    _self.saveCodeFile(sPath, sfilePackage, sout, getJavaName(fname) + "TemplateGen", ".java");
                }

                cb(file, false);
            }
            console.log("********************************************");
        }
    }

    /**
     * 存储文件
     */
    private saveCodeFile(dir: string, filePackage: string, content: string, fname: string, ext = ".ts") {
        if (!content) {
            return;
        }
        if (dir) {
            fname += ext;
            let fullPath = filePackage ? path.join(dir, filePackage) : dir;
            if (!fs.existsSync(fullPath)) {
                mkdirs(fullPath);
            }
            if (fullPath) {
                if (fs.existsSync(fullPath)) {
                    let re = fs.statSync(fullPath);
                    if (re.isDirectory()) {
                        let file = path.join(fullPath, fname);
                        try {
                            fs.writeFileSync(file, content);
                        }
                        catch (e) {
                            error(`写入文件时失败，路径："${fullPath}"，文件名："${fname}"，错误信息：${e.message}\n${e.stack}`);
                            return;
                        }
                        log(`<font color="#0c0">生成代码成功，${file}</font>`);
                        return;
                    }
                }
            }
            error(`生成路径有误，无法生成，路径："${fullPath}"，文件名："${fname}"`);
        }
    }
}

/**
 * 写最终数据
 * @param {any[]} cdatas
 * @param {any[]} sdatas
 */
function writeDesignData(cdatas: any, sdatas: any, fname: string, gcfg: GlobalCfg) {
    fname = getJavaName(fname);
    console.log(fname, gcfg.clientPath, cdatas);
    console.log(fname, gcfg.serverPath, sdatas);
    // 导出客户端数据
    if (cdatas && cdatas.length > 0){
        writeJSONData(fname, gcfg.clientPath, cdatas);
    }
    if (fname != "CfgsSpiltInfo"){
        // 导出服务端数据
        writeJSONData(fname, gcfg.serverPath, sdatas);
    }
}

/**
 * 向文件写入JSON数据
 * 
 * @export
 * @param {File} file 拖入的文件
 * @param {string} directory 要存储的文件路径
 * @param {*} data 数据
 * @returns {string}   存储成功返回文件路径<br/>
 *                     存储失败返回null
 */
function writeJSONData(fname: string, directory: string, data: any) {
    const path = nodeRequire("path");
    const fs = nodeRequire("fs");
    if (fs.existsSync(directory)) {
        let stat = fs.statSync(directory);
        if (stat.isDirectory()) {
            let outpath = path.join(directory, fname + ".json");
            let b = fs.existsSync(outpath);
            fs.writeFileSync(outpath, JSON.stringify(data));
            if (outpath) {
                log(`文件${fname}，将数据保存至：${outpath}`);
            } else {
                log(`文件${fname}，未将数据保存到${outpath}，请检查`)
            }
        }
    }
}

/**
 * 保存屏蔽字数据
 * @param gcfg 
 * @param data 
 */
function writeDirtyData(gcfg: GlobalCfg, data: string[])
{
    let content = data.join(";");
    let url, name;
    if (gcfg.dirtyClientPath){
        // name = gcfg.dirtyClientName ? gcfg.dirtyClientName : "dirty.js";
        // name = name.indexOf(".") == -1 ? name + ".js" : name;
        // url = path.join(gcfg.dirtyClientPath, gcfg.dirtyClientName);
        // fs.writeFileSync(url, `var $dirty="${content}"`);
        let result = {msg: content};
        name = gcfg.dirtyClientName ? gcfg.dirtyClientName : "dirty.json";
        name = name.indexOf(".") == -1 ? name + ".json" : name;
        url = path.join(gcfg.dirtyClientPath, name);
        fs.writeFileSync(url, JSON.stringify(result));
        log(`将客户端【屏蔽字】数据保存至：${url}`);
    } else {
        alert("client 屏蔽字 保存 path 不存在");
    }
    
    if (gcfg.serverPath){
        name = gcfg.dirtyServerName ? gcfg.dirtyServerName : "dirty.txt";
        name = name.indexOf(".") == -1 ? name + ".txt" : name;
        url = path.join(gcfg.serverPath, gcfg.dirtyServerName);
        fs.writeFileSync(url, content);
        log(`将服务端【屏蔽字】数据保存至：${url}`);
    } else {
        alert("server 屏蔽字 保存 path 不存在");
    }
}


/**
 * 保存名字库数据
 * @param gcfg 
 * @param data 
 */
function writeNameLibData(gcfg: GlobalCfg, data: any)
{
    let content = JSON.stringify(data);
    let url, name;
    if (gcfg.nameLibClientPath){
        name = gcfg.nameLibClientName ? gcfg.nameLibClientName : "namelib.json";
        name = name.indexOf(".") == -1 ? name + ".json" : name;
        url = path.join(gcfg.nameLibClientPath, name);
        fs.writeFileSync(url, content);
        log(`将客户端【名字库】数据保存至：${url}`);
    } else {
        alert("client 名字库 保存 path 不存在");
    }
}

function getJavaName(name: string) {
    return name[0].toUpperCase() + name.substr(1);
}

function getNameNoSymbol(name: string) {
    let str = name.split('_');
    let ret = '';
    if (str.length == 1) {
        return name;
    } else {
        for (let i = 0; i < str.length; i++) {
            if (i > 0) {
                ret += str[i].replace(/^\S/, function (s) { return s.toUpperCase(); });
            } else {
                ret += str[i];
            }
        }
        return ret;
    }
}

function split(filePath: string): string[] {
    return path.normalize(filePath).split(path.sep);
}

function mkdirs(filePath: string) {
    mkdir(split(filePath));
}

function mkdir(paths: string[]) {
    var len = paths.length;
    if (len == 0) {
        throw Error("路径无效" + paths);
    }
    var p = paths[0] || '/';
    if (!fs.existsSync(p)) {
        throw Error("没有根目录" + p);
    }
    for (var i = 1, len = paths.length; i < len; i++) {
        p = path.join(p, paths[i]);
        if (fs.existsSync(p)) {
            var ret = fs.statSync(p);
            if (!ret.isDirectory()) {
                throw Error("无法创建文件夹" + p);
            }
        } else {
            fs.mkdirSync(p);
        }
    }
}        

/////////////////////// code template /////////////////

var clientVarsTemplateCode = `
        /**
         * {desc}
         */
        public {varName}: {varType};

`;
var serverVarsTemplateCode = `
    @Attribute("{cfgName}") 
    private {varType} {varName};

    /**
    * {desc}
    */
    public {varType} get{getJavaName}(){
        return {varName};
    }
`;

var clientConfigTemplateCode = `
module giant.chuanqi 
{
	{area1}
	/**
	 * 来自：{filePath}
	 **/
	export class {className}Cfg {extends_implements}
	{
		
		{vars}
	
		/////////////////////

		{area2}

		public decode(data:any[]){

            let i = 0;
            let self = this;
			
			{decodeValue}

			{decode}
		}
	}
	
	{area3}
}
module giant {
	export interface CfgName {
		{className}: { [index: number]: chuanqi.{className}Cfg };
	}
}
`;

var clientGConfigScriptTemplateCode = `
module giant.chuanqi {
	export function initData() {
		var rP = DataParser.regCommonParser.bind(DataParser);
            
		DataParser.regParser("maps", MapConfigParser);
		DataParser.regParser("pst", PstConfigParser);
        DataParser.regParser("ani", AniConfigParser);
        
		//begin
		{content}
		//end
	}

}
`;

var serverConfigTemplateCode = `
package com.game.resources.template.gen.{packageName};

import com.game.resources.annotation.Attribute;
import com.game.resources.annotation.Template;

@Template( res = "{configName}.json")
public abstract class {className}TemplateGen {

    {vars}
	
}
`;